//
//  ViewController.swift
//  GCDKitSample
//
//  Created by oga on 2014/09/23.
//  Copyright (c) 2014年 example. All rights reserved.
//

import UIKit
import GCDKit

class ViewController: UIViewController {

	override func viewDidLoad() {
		super.viewDidLoad()
		noUseKitAsyncSample()
		useKitAsyncSample()
		noUseKitGroupAsyncSample()
		useKitGroupAsyncSample()
	}

	override func didReceiveMemoryWarning() {
		super.didReceiveMemoryWarning()
		// Dispose of any resources that can be recreated.
	}

	func noUseKitAsyncSample() {
		dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0)) {
			sleep(3)
			dispatch_async(dispatch_get_main_queue()) {
				println("noUseKitAsyncSample done")
			}
		}
	}
	func useKitAsyncSample() {
		GCDBlock.async(.Default) {
			sleep(3)
			return
		}.notify(.Main) {
			println("useKitAsyncSample done")
		}
	}
	
	func noUseKitGroupAsyncSample() {
		let queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0)
		let group = dispatch_group_create()
		
		dispatch_group_async(group, queue) {
			sleep(5)
			println("async1 done")
		}
		dispatch_group_async(group, queue) {
			sleep(4)
			println("async2 done")
		}
		dispatch_group_notify(group, dispatch_get_main_queue()) { () -> Void in
			println("all done")
		}
		dispatch_group_wait(group, DISPATCH_TIME_FOREVER)
	}
	func useKitGroupAsyncSample() {
		let group: GCDGroup = GCDGroup()
		
		group.async(.Default) {
			sleep(5)
			println("async1 done")
		}.async(.Default) {
			sleep(4)
			println("async2 done")
		}.notify(.Main) {
			println("all done")
		}
		group.wait()
	}
}

